/*
 * Created on 2005/01/25
 *
 *
 * Copyright(c) 2005 Yoshimasa Matsumoto
 */
package netjfwatcher.engine.nodemaneger.list;

import org.eclipse.jface.resource.FontRegistry;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.viewers.IFontProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;


/**
 * m[hXge[u Label/Font ProviderNXłB
 *
 * @author Yoshimasa Matsumoto
 * @version 1.0
 */
public class NodeListTableViewLabelProvider implements ITableLabelProvider,
    IFontProvider {
    /** m[hXge[uHeader */
    public static final String[] NODE_LIST_TABLE_COLUMNS =
        new String[] {
            "No.", "Node Name", "Group", "IP Address", "Node register date",
            "Last check date", "Status"
        };

    /** m[hNo.J */
    public static final int NODE_LIST_COLUMN_NO = 0;

    /** m[hJ */
    public static final int NODE_LIST_COLUMN_NODENAME = 1;

    /** m[hO[vJ */
    public static final int NODE_LIST_COLUMN_GROUP = 2;

    /** m[hIPAhXJ */
    public static final int NODE_LIST_COLUMN_IPADDRESS = 3;

    /** m[ho^J */
    public static final int NODE_LIST_COLUMN_NODE_REGISTER_DATE = 4;

    /** m[hŐV`FbNJ */
    public static final int NODE_LIST_COLUMN_NODE_LAST_CHECK_DATE = 5;

    /** m[hbZ[WJ */
    public static final int NODE_LIST_COLUMN_STATUS = 6;

    /*
     *  (non-Javadoc)
     * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object, int)
     */
    public Image getColumnImage(Object element, int columnIndex) {
        return null;
    }

    /*
     *  (non-Javadoc)
     * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object, int)
     */
    public String getColumnText(Object element, int columnIndex) {
        String[] test = (String[]) element;

        return test[columnIndex];
    }

    /*
     *  (non-Javadoc)
     * @see org.eclipse.jface.viewers.IFontProvider#getFont(java.lang.Object)
     */
    public Font getFont(Object element) {
        FontRegistry fr = JFaceResources.getFontRegistry();

        return fr.get(JFaceResources.DEFAULT_FONT);
    }

    /*
     *  (non-Javadoc)
     * @see org.eclipse.jface.viewers.
     * IBaseLabelProvider#isLabelProperty(java.lang.Object, java.lang.String)
     */
    public boolean isLabelProperty(Object element, String property) {
        return true;
    }

    /*
     *  (non-Javadoc)
     * @see org.eclipse.jface.viewers.
     * IBaseLabelProvider#addListener(org.eclipse.jface.viewers.ILabelProviderListener)
     */
    public void addListener(ILabelProviderListener listener) {
    }

    /*
     *  (non-Javadoc)
     * @see org.eclipse.jface.viewers.IBaseLabelProvider#dispose()
     */
    public void dispose() {
    }

    /*
     *  (non-Javadoc)
     * @see org.eclipse.jface.viewers.
     * IBaseLabelProvider#removeListener(org.eclipse.jface.viewers.ILabelProviderListener)
     */
    public void removeListener(ILabelProviderListener listener) {
    }
}
