/*
 * Created on 2005/01/25
 *
 *
 * Copyright(c) 2005 Yoshimasa Matsumoto
 */
package netjfwatcher.engine.nodemaneger.list;

import java.util.logging.Logger;

import netjfwatcher.common.view.AbstractNodeTreeView;
import netjfwatcher.common.view.NodeTree;
import netjfwatcher.common.view.NodeTreeGroup;
import netjfwatcher.engine.model.action.ActionBuilderDatabaseWatch;
import netjfwatcher.engine.model.action.ActionBuilderNetworkCamera;
import netjfwatcher.engine.model.action.ListenerNodeListTree;
import netjfwatcher.engine.model.action.ActionBuilderAlarmList.ActionOpenEditorPartPersonalNodeAlarm;
import netjfwatcher.engine.model.action.ActionBuilderDatabaseWatch.ActionDatabaseWatch;
import netjfwatcher.engine.model.action.ActionBuilderNetworkCamera.ActionNetworkCamera;
import netjfwatcher.engine.model.action.ActionBuilderNodeOperation.ActionNodeOperation;
import netjfwatcher.engine.model.action.ActionBuilderNodeOperation.ActionShowNodeView;
import netjfwatcher.engine.model.action.ActionBuilderSnmp.ActionShowNodeSnmpView;
import netjfwatcher.engine.model.action.ActionBuilderSnmp.ActionSnmpPrint;
import netjfwatcher.engine.model.action.ActionBuilderSnmp.ActionSnmpStatisticsSet;
import netjfwatcher.engine.nodecontrol.NodeKind;
import netjfwatcher.engine.socket.info.NodeInformation;
import netjfwatcher.engine.view.editorpart.ping.NodePingMenu;
import netjfwatcher.engine.view.editorpart.snmp.NodeSnmpStatisticsMenu;

import org.eclipse.jface.action.GroupMarker;
import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.ui.IWorkbenchActionConstants;



/**
 * m[hTree\ViewNXłB
 *
 * @author Yoshimasa Matsumoto
 * @version 1.0
 */
public class NodeListTreeView extends AbstractNodeTreeView {
    /* MO */
    private static Logger logger = null;

    /* SNMPv\j[ */
    private NodeSnmpStatisticsMenu nodeSnmpStatisticsMenu =
        new NodeSnmpStatisticsMenu();

    /* Pingf[^\j[ */
    private NodePingMenu nodePingMenu = new NodePingMenu();

    /* Network Camera m[h֘ÃANV */
    private ActionBuilderNetworkCamera networkCameraAction = new ActionBuilderNetworkCamera();
    
    /* DatabaseĎ֘ÃANV */
    private ActionBuilderDatabaseWatch databaseWatchAction = new ActionBuilderDatabaseWatch();
    
    /**
     * m[hTree\ViewNXCX^X𐶐܂B
     *
     */
    public NodeListTreeView() {
        logger = Logger.getLogger(this.getClass().getName());
    }

    /**
     * f[^x[Xm[hĎ񃊃XgǂݍTree\
     * ܂B
     *
     */
    protected void initShow() {
        /* ((ActionReloadNodeTreeDatabase) actionNodeTree.
         * actionReloadNodeTreeDatabase()).setNodeTree();
        */
    }

    /**
     * ReLXgj[𐶐܂B
     *
     */
    public void createContextMenu() {
        /* j[}l[W */
        MenuManager mm = new MenuManager();
        mm.setRemoveAllWhenShown(true);

        /* j[Xi[Zbg */
        mm.addMenuListener(
            new IMenuListener() {
                public void menuAboutToShow(IMenuManager manager) {
                    fillContextMenu(manager);
                }
            });

        Menu menu = mm.createContextMenu(nodeListTreeViewer.getControl());
        nodeListTreeViewer.getControl().setMenu(menu);
        getSite().registerContextMenu(mm, nodeListTreeViewer);
    }

    /**
     * ANV̏ƂToolBarݒ肵܂B
     *
     */
    protected void setToolBarActions() {
        /* ToolBarݒ */
        IToolBarManager toolBarManager =
            getViewSite().getActionBars().getToolBarManager();

        /* m[hTreeēǍANV */
        toolBarManager.add(
            getActionNodeTreeBuilder().actionReloadNodeTreeDatabase());
        toolBarManager.add(
            getActionNodeTreeBuilder().actionSortNodeTreeDatabase());
        toolBarManager.add(actionBuilderNodeOperation.getActionNodeOperation());
        toolBarManager.add(actionBuilderEditorPart.actionCloseAllEditors());
    }

    /**
     * j[o[ݒ肵܂B
     * preWindowOpenɌĂ΂܂B
     * m[hTreẽm[hIĂꍇƑIĂȂꍇ
     * j[ς܂B
     *
     * @param manager IMenuManager
     */
    protected void fillContextMenu(IMenuManager manager) {
        /* m[hTreeǂݍ݃ANVZbg */
        manager.add(new GroupMarker(IWorkbenchActionConstants.MB_ADDITIONS));

        /* m[hTreeēǂݍ */
        manager.add(getActionNodeTreeBuilder().actionReloadNodeTreeDatabase());

        /* m[hTree\[g */
        manager.add(getActionNodeTreeBuilder().actionSortNodeTreeDatabase());

        /*
         * Treẽm[hIĂ邩`FbN
         */
        if (nodeListTreeViewer.getTree().getSelection() != null) {
            TreeItem[] treeItem = nodeListTreeViewer.getTree().getSelection();

            if ((treeItem != null) && (treeItem.length > 0)) {
                for (
                    int nodeTreeSelectNo = 0;
                        nodeTreeSelectNo < treeItem.length;
                        nodeTreeSelectNo++) {
                    if (
                        treeItem[nodeTreeSelectNo].getData() instanceof NodeTreeGroup) {
                        /* GroupI */
                        nodeListTreeViewer.getTree().deselectAll();
                    } else if (
                        treeItem[nodeTreeSelectNo].getData() instanceof NodeTree) {
                        NodeInformation targetNodeInfo =
                            ((NodeTree) treeItem[nodeTreeSelectNo].getData())
                            .getNodeInfo();

                        /* m[h\`j[ǉ */
                        ((ActionShowNodeView) actionBuilderNodeOperation
                        .getActionShowNodeView()).setNodeInfo(targetNodeInfo);
                        manager.add(
                            actionBuilderNodeOperation.getActionShowNodeView());

                        /* m[hAlarmj[ǉ */
                        ((ActionOpenEditorPartPersonalNodeAlarm) actinAlarm
                        .getActionOpenEditorPartPersonalNodeAlarm())
                        .setNodeInfo(targetNodeInfo);
                        manager.add(
                            actinAlarm.getActionOpenEditorPartPersonalNodeAlarm());

                        /* m[hSNMP\j[ǉ */
                        ((ActionShowNodeSnmpView) snmpAction.getActionSnmpInfo())
                        .setNodeInfo(targetNodeInfo);
                        manager.add(snmpAction.getActionSnmpInfo());

                        /* m[hǉEҏWE폜j[ǉ */
                        ((ActionNodeOperation) actionBuilderNodeOperation
                        .getActionNodeOperation()).setNodeInfo(targetNodeInfo);
                        manager.add(
                            actionBuilderNodeOperation.getActionNodeOperation());

                        /*
                         * m[hPingf[^j[j[}l[W
                         * ǉ
                         */
                        nodePingMenu.createPingMenu(
                            manager, targetNodeInfo, false);

                        /*
                         * m[hSnmpv\j[j[}l[W
                         * ɒǉ
                         */
                        nodeSnmpStatisticsMenu.createSnmpStatisticsMenu(
                            manager, targetNodeInfo, false);

                        /*
                         * m[hSnmpvZbgj[j[}l[W
                         * ɒǉ
                         */
                        ((ActionSnmpStatisticsSet) snmpAction
                        .getActionSnmpStatisticsSet()).setNodeInfo(
                            targetNodeInfo);
                        manager.add(snmpAction.getActionSnmpStatisticsSet());
                        
                        /* DatabaseĎj[ǉ */
                        ((ActionDatabaseWatch) databaseWatchAction.getActionDatabaseWatch())
                        .setNodeInfo(targetNodeInfo);
                        manager.add(databaseWatchAction.getActionDatabaseWatch());
                        
                        if(targetNodeInfo.getNodeKind().equals(NodeKind.PRINTER)) {
                        	/* Printerm[hSNMP\j[ǉ */
                            ((ActionSnmpPrint) snmpAction.getActionPrintSnmp())
                            .setNodeInfo(targetNodeInfo);
                            manager.add(snmpAction.getActionPrintSnmp());
                        }
                        if(targetNodeInfo.getNodeKind().equals(NodeKind.CAMERA)) {
                        	/* Network Cameraj[ǉ */
                            ((ActionNetworkCamera) networkCameraAction.getActionNetworkCamera())
                            .setNodeInfo(targetNodeInfo);
                            manager.add(networkCameraAction.getActionNetworkCamera());
                        }
                    } else {
                        /* Groupłm[hłȂ */
                        nodeListTreeViewer.getTree().deselectAll();
                    }
                }
            } else {
                /* TreeI */
                manager.add(
                    actionBuilderNodeOperation.getActionNodeOperation());
            }
        }

        /* SNMPvr[\ */
        manager.add(snmpAction.getActionSnmpStatistics());

        /* Sm[hAlarmr[\ */
        manager.add(actinAlarm.getActionShowAllNodeAlarmListTable());
        /* m[hor[\ */
        manager.add(actionBuilderNodeDetect.getActionNodeDetectView());
    }

    /**
     * m[hTree View̑IXi[ݒ肵܂B
     *
     */
    protected void setupNodeTreeViewListener() {
        /*
         * Node Tree ViewɃXi[o^
         * Xi[̏ƂẮA
         * e[uViewɃtB[hꗗőIGg͒lƂĐݒ
         *
         */
        nodeListTreeViewer.addSelectionChangedListener(
            new ListenerNodeListTree(false));
    }
}
