/*
 * Created on 2004/09/28
 *
 *
 * Copyright(c) 2004 Yoshimasa Matsumoto
 */
package netjfwatcher.engine.snmpmanager.process;

import java.net.DatagramSocket;
import java.net.InetAddress;
import java.util.logging.Logger;

import netjfwatcher.snmp.messageformat.SnmpConfigurationException;
import netjfwatcher.snmp.preference.SnmpPreference;
import netjfwatcher.snmp.snmpv3.SnmpV3ConfigurationException;



/**
 * SNMP V1 }l[Wł̏sNXłB
 *
 * @author Yoshimasa Matsumoto
 * @version 1.0
 */
public class ManagerV1MP extends AbstractManagerV1V2MP {
    /* MO */
    private static Logger logger;

    /**
     * SNMP V1 }l[Wł̏sNXCX^X𐶐܂B
     *
     */
    public ManagerV1MP() {
        logger = Logger.getLogger(this.getClass().getName());
    }

    /**
     * SNMP V1}l[WCX^X𐶐܂B
     *
     * @param dSocket DatagramSocket
     * @param hostAddress AgnetAhX
     * @param community R~jeB
     * @throws SnmpConfigurationException SNMP\`񂪈ُȏꍇ
     * @throws SnmpV3ConfigurationException SNMP V3\`񂪈ُȏꍇ
     */
    public ManagerV1MP(
        DatagramSocket dSocket, InetAddress hostAddress, String community)
        throws SnmpConfigurationException, SnmpV3ConfigurationException {
        logger = Logger.getLogger(this.getClass().getName());

        /* SNMP Ver.1Zbg */
        this.version = SnmpPreference.SNMP_VERSION_1;
        this.dSocket = dSocket;
        this.targetAddress = hostAddress;
        this.community = community;

        this.setConfig(dSocket, hostAddress);
    }

    /**
     * SNMP V1}l[WCX^X̃vpeBZbg܂B
     *
     * @param dSocket DatagramSocket
     * @param hostAddress AgnetAhX
     * @param community R~jeB
     * @throws SnmpConfigurationException SNMP\`񂪈ُȏꍇ
     * @throws SnmpV3ConfigurationException SNMP V3\`񂪈ُȏꍇ
     */
    public void setManagerMP(
        DatagramSocket dSocket, InetAddress hostAddress, String community)
        throws SnmpConfigurationException, SnmpV3ConfigurationException {
        /* SNMP Ver.1Zbg */
        this.version = SnmpPreference.SNMP_VERSION_1;
        this.dSocket = dSocket;
        this.targetAddress = hostAddress;
        this.community = community;

        this.setConfig(dSocket, hostAddress);
    }
}
