/*
 * Created on 2004/12/15
 *
 *
 * Copyright(c) 2004 Yoshimasa Matsumoto
 */
package netjfwatcher.engine.socket.info;

import java.io.Serializable;


/**
 * m[h̊ĎێNXłB
 * m[ho^EҏWE폜Am[hXg\m[hMap\A܂AMIB̎AMIBZbgɃCX^Xgp܂B
 *
 * @author Yoshimasa Matsumoto
 * @version 1.0
 */
public class NodeInformation implements Serializable {
    /**
     * serialVersionUID
     */
    private static final long serialVersionUID = 3972236196703030975L;

    /* m[ho^GWAhX */
    private String engineAddress;

    /* TuR}h */
    private String subCommand;

    /* m[hXg\[gJ */
    private String sortColumn;

    /* m[hXg\[g */
    private String sortDirection;

    /* m[hXg\m[hԍ */
    private String nodeNumber;

    /* m[hXg\/ԍ */
    private String numberEvenOdd;

    /* m[h */
    private String nodename;

    /* m[hIPAhX */
    private String ipaddress;

    /* m[hO[v */
    private String group;

    /* m[hMap̃m[hXW */
    private String nodeX;

    /* m[hMap̃m[hYW */
    private String nodeY;

    /* m[h */
    private String nodeKind;

    /* m[hComboBoxILq */
    private String selected;

    /* PingĎ */
    private String pingPeriod;

    /* Ping臒l */
    private String pingThreshold;

    /* SNMPo[W */
    private String snmpVersion;

    /* SNMPĎx */
    private String snmpLevel;

    /* SNMPĎ */
    private String snmpPeriod;

    /* SNMPĎ^CAEgl */
    private String snmpTimeout;

    /* SNMP ReadR~jeB */
    private String roCommunity;

    /* SNMP Read/WriteR~jeB */
    private String rwCommunity;

    /* m[ho^ */
    private String registerDate;

    /* m[hIPAhX[.][_]ɕύXꂽl */
    private String convIPAddress;

    /* A[ID */
    private String alarmID;

    /* A[R[h */
    private String alarmCode;

    /* A[x */
    private String alarmLevel;

    /* A[bZ[W */
    private String alarmMessage;

    /* A[mFς/mFR[h */
    private String alarmConfirm;

    /* A[o */
    private String alarmDate;

    /* HTTPĎ */
    private String httpPeriod;

    /* HTTPĎ|[g */
    private String httpPort;

    /* HTPPĎ^CAEgl */
    private String httpTimeout;

    /* Pop3ĎURL */
    private String httpUrl;

    /* Pop3Ď */
    private String popPeriod;

    /* Pop3Ď^CAEgl */
    private String popTimeout;

    /* Pop3Ď[U */
    private String popUser;

    /* Pop3ĎpX[h */
    private String popPassword;

    /* Pop3Ď|[g */
    private String popPort;

    /* SMTPĎ */
    private String smtpPeriod;

    /* SMTPĎ|[g */
    private String smtpPort;

    /* SMTPM^CAEgl */
    private String smtpTimeout;

    /* SMTPMAhX */
    private String smtpSendAddress;

    /* SMTPM`FbNPop3zXg */
    private String smtpCheckHost;

    /* SMTPM`FbNPop3[U */
    private String smtpCheckUser;

    /* SMTPM`FbNPop3pX[h */
    private String smtpCheckPassword;

    /* SMTPM`FbNPop3|[g */
    private String smtpCheckPort;

    /* SMTPM`FbNPop3^CAEgl */
    private String smtpCheckTimeout;

    /* m[hĎŐV`FbN */
    private String lastCheck;

    /* f[^x[XĎ */
    private DatabaseWatcherInfo databaseWatcherInfo;

    /**
     * A[R[hԂ܂B
     *
     * @return alarmCode A[R[h
     */
    public String getAlarmCode() {
        return alarmCode;
    }

    /**
     * A[mFς/mFR[hԂ܂B
     *
     * @return alarmConfirm A[mFς/mFR[h
     */
    public String getAlarmConfirm() {
        return alarmConfirm;
    }

    /**
     * A[oԂ܂B
     *
     * @return alarmDate A[o
     */
    public String getAlarmDate() {
        return alarmDate;
    }

    /**
     * A[IDԂ܂B
     *
     * @return alarmID A[ID
     */
    public String getAlarmID() {
        return alarmID;
    }

    /**
     * A[xԂ܂B
     *
     * @return alarmLevel A[x
     */
    public String getAlarmLevel() {
        return alarmLevel;
    }

    /**
     * A[bZ[WԂ܂B
     *
     * @return alarmMessage A[bZ[W
     */
    public String getAlarmMessage() {
        return alarmMessage;
    }

    /**
     * m[hIPAhX[.][_]ɕύXꂽlԂ܂B
     * @return convIPAddress m[hIPAhX[.][_]ɕύXꂽl
     */
    public String getConvIPAddress() {
        return convIPAddress;
    }

    /**
     * m[hO[vԂ܂B
     *
     * @return group m[hO[v
     */
    public String getGroup() {
        return group;
    }

    /**
     * HTTPĎԂ܂B
     *
     * @return httpPeriod HTTPĎ
     */
    public String getHttpPeriod() {
        return httpPeriod;
    }

    /**
     * HTTPĎ|[gԂ܂B
     *
     * @return httpPort HTTPĎ|[g
     */
    public String getHttpPort() {
        return httpPort;
    }

    /**
     * HTTPĎ^CAEglԂ܂B
     *
     * @return httpTimeout HTTPĎ^CAEgl
     */
    public String getHttpTimeout() {
        return httpTimeout;
    }

    /**
     * HTTPĎURLԂ܂B
     *
     * @return httpUrl HTTPĎURL
     */
    public String getHttpUrl() {
        return httpUrl;
    }

    /**
     * m[hIPAhXԂ܂B
     *
     * @return ipaddress m[hIPAhX
     */
    public String getIpaddress() {
        return ipaddress;
    }

    /**
     * m[hĎŐV`FbNԂ܂B
     *
     * @return lastCheck m[hĎŐV`FbN
     */
    public String getLastCheck() {
        return lastCheck;
    }

    /**
     * m[hʂԂ܂B
     *
     * @return nodeKind m[h
     */
    public String getNodeKind() {
        return nodeKind;
    }

    /**
     * m[hԂ܂B
     *
     * @return nodename m[h
     */
    public String getNodename() {
        return nodename;
    }

    /**
     * m[hXg\m[hԍԂ܂B
     *
     * @return nodeNumber m[hXg\m[hԍ
     */
    public String getNodeNumber() {
        return nodeNumber;
    }

    /**
     * m[hMapł̃m[hXWԂ܂B
     *
     * @return nodeX m[hMapł̃m[hXW
     */
    public String getNodeX() {
        return nodeX;
    }

    /**
     * m[hMapł̃m[hYWԂ܂B
     *
     * @return nodeY m[hMapł̃m[hYW
     */
    public String getNodeY() {
        return nodeY;
    }

    /**
     * m[hXg\/ԍԂ܂B
     *
     * @return numberEvenOdd m[hXg\/ԍ
     */
    public String getNumberEvenOdd() {
        return numberEvenOdd;
    }

    /**
     * PingĎԂ܂B
     *
     * @return pingPeriod PingĎ
     */
    public String getPingPeriod() {
        return pingPeriod;
    }

    /**
     * PingĎ臒lԂ܂B
     *
     * @return pingThreshold PingĎ臒l
     */
    public String getPingThreshold() {
        return pingThreshold;
    }

    /**
     * Pop3ĎԂ܂B
     *
     * @return popPeriod Pop3Ď
     */
    public String getPopPeriod() {
        return popPeriod;
    }

    /**
     * Pop3Ď^CAEglԂ܂B
     *
     * @return popTimeout Pop3Ď^CAEgl
     */
    public String getPopTimeout() {
        return popTimeout;
    }

    /**
     * m[ho^Ԃ܂B
     *
     * @return registerDate m[ho^
     */
    public String getRegisterDate() {
        return registerDate;
    }

    /**
     * SNMP ReadR~jeBԂ܂B
     *
     * @return roCommunity SNMP ReadR~jeB
     */
    public String getRoCommunity() {
        return roCommunity;
    }

    /**
     * SNMP Read/WriteR~jeBԂ܂B
     *
     * @return rwCommunity SNMP Read/WriteR~jeB
     */
    public String getRwCommunity() {
        return rwCommunity;
    }

    /**
     * SMTPĎԂ܂B
     *
     * @return smtpPeriod SMTPĎ
     */
    public String getSmtpPeriod() {
        return smtpPeriod;
    }

    /**
     * SMTPĎ|[gԂ܂B
     *
     * @return smtpPort SMTPĎ|[g
     */
    public String getSmtpPort() {
        return smtpPort;
    }

    /**
     * SMTPĎ^CAEglԂ܂B
     *
     * @return smtpTimeout SMTPĎ^CAEgl
     */
    public String getSmtpTimeout() {
        return smtpTimeout;
    }

    /**
     * SNMPĎxԂ܂B
     *
     * @return snmpLevel SNMPĎx
     */
    public String getSnmpLevel() {
        return snmpLevel;
    }

    /**
     * SNMPĎԂ܂B
     *
     * @return snmpPeriod SNMPĎ
     */
    public String getSnmpPeriod() {
        return snmpPeriod;
    }

    /**
     * SNMPĎ^CAEglԂ܂B
     *
     * @return snmpTimeout SNMPĎ^CAEgl
     */
    public String getSnmpTimeout() {
        return snmpTimeout;
    }

    /**
     * SNMPo[WԂ܂B
     *
     * @return snmpVersion SNMPo[W
     */
    public String getSnmpVersion() {
        return snmpVersion;
    }

    /**
     * A[R[hZbg܂B
     *
     * @param string A[R[h
     */
    public void setAlarmCode(String string) {
        alarmCode = string;
    }

    /**
     * A[mFς/mFR[hZbg܂B
     *
     * @param string A[mFς/mFR[h
     */
    public void setAlarmConfirm(String string) {
        alarmConfirm = string;
    }

    /**
     * A[oZbg܂B
     *
     * @param string A[o
     */
    public void setAlarmDate(String string) {
        alarmDate = string;
    }

    /**
     * A[IDZbg܂B
     *
     * @param string A[ID
     */
    public void setAlarmID(String string) {
        alarmID = string;
    }

    /**
     * A[xZbg܂B
     *
     * @param string A[x
     */
    public void setAlarmLevel(String string) {
        alarmLevel = string;
    }

    /**
     * A[bZ[WZbg܂B
     *
     * @param string A[bZ[W
     */
    public void setAlarmMessage(String string) {
        alarmMessage = string;
    }

    /**
     * m[hIPAhX[.][_]ɕύXꂽlZbg܂B
     *
     * @param string m[hIPAhX[.][_]ɕύXꂽl
     */
    public void setConvIPAddress(String string) {
        convIPAddress = string;
    }

    /**
     * m[hO[vZbg܂B
     *
     * @param string m[hO[v
     */
    public void setGroup(String string) {
        group = string;
    }

    /**
     * HTTPĎZbg܂B
     *
     * @param string HTTPĎ
     */
    public void setHttpPeriod(String string) {
        httpPeriod = string;
    }

    /**
     * HTTPĎ|[gZbg܂B
     *
     * @param string HTTPĎ|[g
     */
    public void setHttpPort(String string) {
        httpPort = string;
    }

    /**
     * HTTPĎ^CAEglZbg܂B
     *
     * @param string HTTPĎ^CAEgl
     */
    public void setHttpTimeout(String string) {
        httpTimeout = string;
    }

    /**
     * HTTPĎURLZbg܂B
     *
     * @param string  HTTPĎURL
     */
    public void setHttpUrl(String string) {
        httpUrl = string;
    }

    /**
     * m[hIPAhXZbg܂B
     *
     * @param string m[hIPAhX
     */
    public void setIpaddress(String string) {
        ipaddress = string;
    }

    /**
     * m[hĎŐV`FbNZbg܂B
     *
     * @param string m[hĎŐV`FbN
     */
    public void setLastCheck(String string) {
        lastCheck = string;
    }

    /**
     * m[hʂZbg܂B
     *
     * @param string m[h
     */
    public void setNodeKind(String string) {
        nodeKind = string;
    }

    /**
     * m[hZbg܂B
     *
     * @param string m[h
     */
    public void setNodename(String string) {
        nodename = string;
    }

    /**
     * m[hXg\m[hԍZbg܂B
     *
     * @param string m[hXg\m[hԍ
     */
    public void setNodeNumber(String string) {
        nodeNumber = string;
    }

    /**
     * m[hMap\XWZbg܂B
     *
     * @param string m[hMap\XW
     */
    public void setNodeX(String string) {
        nodeX = string;
    }

    /**
     * m[hMap\YWZbg܂B
     *
     * @param string m[hMap\YW
     */
    public void setNodeY(String string) {
        nodeY = string;
    }

    /**
     * m[hXg\/ԍZbg܂B
     *
     * @param string m[hXg\/ԍ
     */
    public void setNumberEvenOdd(String string) {
        numberEvenOdd = string;
    }

    /**
     * PingĎZbg܂B
     *
     * @param string PingĎ
     */
    public void setPingPeriod(String string) {
        pingPeriod = string;
    }

    /**
     * PingĎ臒lZbg܂B
     *
     * @param string PingĎ臒l
     */
    public void setPingThreshold(String string) {
        pingThreshold = string;
    }

    /**
     * Pop3ĎZbg܂B
     *
     * @param string Pop3Ď
     */
    public void setPopPeriod(String string) {
        popPeriod = string;
    }

    /**
     * Pop3Ď^CAEglZbg܂B
     *
     * @param string Pop3Ď^CAEgl
     */
    public void setPopTimeout(String string) {
        popTimeout = string;
    }

    /**
     * m[ho^Zbg܂B
     *
     * @param string m[ho^
     */
    public void setRegisterDate(String string) {
        registerDate = string;
    }

    /**
     * SNMP ReadR~jeBZbg܂B
     *
     * @param string SNMP Read/WriteR~jeB
     */
    public void setRoCommunity(String string) {
        roCommunity = string;
    }

    /**
     * SNMP Read/WriteR~jeBZbg܂B
     *
     * @param string SNMP Read/WriteR~jeB
     */
    public void setRwCommunity(String string) {
        rwCommunity = string;
    }

    /**
     * SMTPĎZbg܂B
     *
     * @param string SMTPĎ
     */
    public void setSmtpPeriod(String string) {
        smtpPeriod = string;
    }

    /**
     * SMTPĎ|[gZbg܂B
     *
     * @param string SMTPĎ|[g
     */
    public void setSmtpPort(String string) {
        smtpPort = string;
    }

    /**
     * SMTPĎ^CAEglZbg܂B
     *
     * @param string SMTPĎ^CAEgl
     */
    public void setSmtpTimeout(String string) {
        smtpTimeout = string;
    }

    /**
     * SNMPĎxZbg܂B
     *
     * @param string SNMPĎx
     */
    public void setSnmpLevel(String string) {
        snmpLevel = string;
    }

    /**
     * SNMPĎZbg܂B
     *
     * @param string SNMPĎ
     */
    public void setSnmpPeriod(String string) {
        snmpPeriod = string;
    }

    /**
     * SNMPĎ^CAEglZbg܂B
     *
     * @param string SNMPĎ^CAEgl
     */
    public void setSnmpTimeout(String string) {
        snmpTimeout = string;
    }

    /**
     * SNMPo[WZbg܂B
     *
     * @param string SNMPo[W
     */
    public void setSnmpVersion(String string) {
        snmpVersion = string;
    }

    /**
     * \[gJԂ܂B
     *
     * @return sortColumn \[gJ
     */
    public String getSortColumn() {
        return sortColumn;
    }

    /**
     * \[gԂ܂B
     *
     * @return sortDirection \[g
     */
    public String getSortDirection() {
        return sortDirection;
    }

    /**
     * \[gJZbg܂B
     *
     * @param string \[gJ
     */
    public void setSortColumn(String string) {
        sortColumn = string;
    }

    /**
     * \[gZbg܂B
     *
     * @param string \[g
     */
    public void setSortDirection(String string) {
        sortDirection = string;
    }

    /**
     * TuR}hԂ܂B
     *
     * @return subCommand TuR}h
     */
    public String getSubCommand() {
        return subCommand;
    }

    /**
     * TuR}hZbg܂B
     *
     * @param string TuR}h
     */
    public void setSubCommand(String string) {
        subCommand = string;
    }

    /**
     * GWAhXԂ܂B
     *
     * @return engineAddress GWAhX
     */
    public String getEngineAddress() {
        return engineAddress;
    }

    /**
     * GWAhXZbg܂B
     *
     * @param string GWAhX
     */
    public void setEngineAddress(String string) {
        engineAddress = string;
    }

    /**
     * m[hComboBoxILqԂ܂B
     *
     * @return selected m[hComboBoxILq
     */
    public String getSelected() {
        return selected;
    }

    /**
     * m[hComboBoxILqZbg܂B
     *
     * @param string m[hComboBoxILq
     */
    public void setSelected(String string) {
        selected = string;
    }

    /**
     * Pop3pX[hԂ܂B
     *
     * @return popPassword Pop3pX[h
     */
    public String getPopPassword() {
        return popPassword;
    }

    /**
     * Pop3pX[hZbg܂B
     *
     * @param popPassword Pop3pX[h
     */
    public void setPopPassword(String popPassword) {
        this.popPassword = popPassword;
    }

    /**
     * Pop3[UԂ܂B
     *
     * @return popUser Pop3[U
     */
    public String getPopUser() {
        return popUser;
    }

    /**
     * Pop3[UZbg܂B
     *
     * @param popUser Pop3[U
     */
    public void setPopUser(String popUser) {
        this.popUser = popUser;
    }

    /**
     * SMTPM`FbNPoppX[hԂ܂B
     *
     * @return smtpCheckPassword SMTPM`FbNPoppX[h
     */
    public String getSmtpCheckPassword() {
        return smtpCheckPassword;
    }

    /**
     * SMTPM`FbNPoppX[hZbg܂B
     *
     * @param smtpCheckPassword SMTPM`FbNPoppX[h
     */
    public void setSmtpCheckPassword(String smtpCheckPassword) {
        this.smtpCheckPassword = smtpCheckPassword;
    }

    /**
     * SMTPM`FbNPop[UԂ܂B
     *
     * @return smtpCheckUser SMTPM`FbNPop[U
     */
    public String getSmtpCheckUser() {
        return smtpCheckUser;
    }

    /**
     * SMTPM`FbNPop[UZbg܂B
     *
     * @param smtpCheckUser SMTPM`FbNPop[U
     */
    public void setSmtpCheckUser(String smtpCheckUser) {
        this.smtpCheckUser = smtpCheckUser;
    }

    /**
     * SMTPM`FbNPopzXgԂ܂B
     *
     * @return smtpCheckHost SMTPM`FbNPopzXg
     */
    public String getSmtpCheckHost() {
        return smtpCheckHost;
    }

    /**
     * SMTPM`FbNPopzXgZbg܂B
     *
     * @param smtpCheckHost SMTPM`FbNPopzXg
     */
    public void setSmtpCheckHost(String smtpCheckHost) {
        this.smtpCheckHost = smtpCheckHost;
    }

    /**
     * SMTPMAhXԂ܂B
     *
     * @return smtpSendAddress SMTPMAhX
     */
    public String getSmtpSendAddress() {
        return smtpSendAddress;
    }

    /**
     * SMTPMAhXݒ肵܂B
     *
     * @param smtpSendAddress SMTPMAhX
     */
    public void setSmtpSendAddress(String smtpSendAddress) {
        this.smtpSendAddress = smtpSendAddress;
    }

    /**
     * Pop3|[gԂ܂B
     *
     * @return popPort Pop3|[g
     */
    public String getPopPort() {
        return popPort;
    }

    /**
     * Pop3|[gZbg܂B
     *
     * @param popPort Pop3|[g
     */
    public void setPopPort(String popPort) {
        this.popPort = popPort;
    }

    /**
     * SMTPM`FbNpPop3|[gԂ܂B
     *
     * @return smtpCheckPort SMTPM`FbNpPop3|[g
     */
    public String getSmtpCheckPort() {
        return smtpCheckPort;
    }

    /**
     * SMTPM`FbNpPop3|[gZbg܂B
     *
     * @param smtpCheckPort SMTPM`FbNpPop3|[g
     */
    public void setSmtpCheckPort(String smtpCheckPort) {
        this.smtpCheckPort = smtpCheckPort;
    }

    /**
     * SMTPM`FbNpPop3 TimeoutԂ܂B
     *
     * @return smtpCheckTimeout SMTPM`FbNpPop3 Timeout
     */
    public String getSmtpCheckTimeout() {
        return smtpCheckTimeout;
    }

    /**
     * SMTPM`FbNpPop3 Timeoutݒ肵܂B
     *
     * @param smtpCheckTimeout SMTPM`FbNpPop3 Timeout
     */
    public void setSmtpCheckTimeout(String smtpCheckTimeout) {
        this.smtpCheckTimeout = smtpCheckTimeout;
    }

	public DatabaseWatcherInfo getDatabaseWatcherInfo() {
		return databaseWatcherInfo;
	}

	public void setDatabaseWatcherInfo(DatabaseWatcherInfo databaseWatcherInfo) {
		this.databaseWatcherInfo = databaseWatcherInfo;
	}
}
