/*
 * Created on 2005/01/27
 *
 *
 * Copyright(c) 2005 Yoshimasa Matsumoto
 */
package netjfwatcher.snmp.mibtree;

import java.util.logging.Logger;

import netjfwatcher.engine.filepreference.FilePreference;



/**
 * MIB`CSVt@C͂AOID Tree𐶐NXłB
 *
 * @author Yoshimasa Matsumoto
 * @version 1.0
 */
public final class ManagerMibTree extends AbstractMibTree {
    /* MO */
    private static Logger logger;

    /**
     * wMIB`t@COID Tree𐶐NXCX^X
     * ܂B
     *
     * @param fileName MIB`t@C
     */
    private ManagerMibTree(String fileName) {
        logger = Logger.getLogger(this.getClass().getName());

        this.parseCSVFile(fileName);
    }

    /**
     *
     *
     * @param fileName
     */
    public void reloadOidTree(String fileName) {
        logger.info("Reload OID define file : " + fileName);

        oidList.clear();
        oidHashMap.clear();
        mibDescripHashMap.clear();

        rootTreeNode = null;

        this.parseCSVFile(fileName);
    }

    /**
     * ̃NX̃CX^XԂ܂B<BR>
     * iNXێĂVOgEIuWFNg
     * Ԃ܂j<BR>
     *
     * @return VOgEIuWFNgƂĂ̂̃NX
     * CX^X
     */
    public static ManagerMibTree getInstance() {
        return SingletonResource.RESOURCE;
    }

    /**
     * VOgEIuWFNgێNXłB<BR>
     *
     */
    private static class SingletonResource {
        static final ManagerMibTree RESOURCE =
            new ManagerMibTree(FilePreference.MANAGER_MIB_DEFINE_FILE);
    }
}
